categories:
  - Server
questions:

  # Config
  - variable: config.clusterType
    description: ''
    type: enum
    options:
      - aks
      - eks
      - gke
      - k3s
      - rke
    required: true
    label: 'cluster type'
    group: Config
  - variable: config.imagePullPolicy
    description: ''
    type: enum
    options:
      - IfNotPresent
      - Always
    required: true
    label: 'pull policy'
    group: Config
  - variable: config.updateStrategy
    description: ''
    type: enum
    options:
      - Recreate
      - RollingUpdate
    required: true
    label: 'update strategy'
    group: Config
  - variable: config.debug
    description: ''
    type: boolean
    required: true
    label: debug
    group: Config
  - variable: config.keycloak.replicas
    description: ''
    type: int
    required: true
    label: 'keycloak replicas'
    group: Config
  - variable: config.keycloak.enablePreview
    description: ''
    type: boolean
    required: false
    label: 'keycloak enable preview'
    group: Config
  - variable: config.keycloak.javaOpts
    description: ''
    type: string
    required: false
    label: 'keycloak java opts'
    group: Config
  - variable: config.keycloak.hostname
    description: ''
    type: string
    required: false
    label: 'keycloak hostname'
    group: Config
  - variable: config.keycloak.adminPassword
    description: ''
    type: password
    required: false
    label: 'keycloak admin password'
    group: Config
  - variable: config.keycloak.themeZip
    description: ''
    type: string
    required: false
    label: 'keycloak theme zip'
    group: Config
  - variable: config.keycloak.defaultTheme
    description: ''
    type: string
    required: false
    label: 'keycloak default theme'
    group: Config
  - variable: config.keycloak.welcomeTheme
    description: ''
    type: string
    required: false
    label: 'keycloak welcome theme'
    group: Config
  - variable: config.keycloak.migrationStrategy
    description: ''
    type: enum
    options:
      - IGNORE_EXISTING
      - OVERWRITE_EXISTING
    required: true
    label: 'keycloak migration strategy'
    group: Config
  - variable: config.keycloak.resources.enabled
    description: ''
    type: enum
    options:
      - defaults
      - custom
      - 'false'
    required: true
    label: 'keycloak resources defaults'
    show_subquestion_if: custom
    group: Config
    subquestions:
      - variable: config.keycloak.resources.requests.cpu
        description: ''
        type: string
        required: true
        label: 'keycloak resources requests cpu'
      - variable: config.keycloak.resources.requests.memory
        description: ''
        type: string
        required: true
        label: 'keycloak resources requests memory'
      - variable: config.keycloak.resources.limits.cpu
        description: ''
        type: string
        required: true
        label: 'keycloak resources limits cpu'
      - variable: config.keycloak.resources.limits.memory
        description: ''
        type: string
        required: true
        label: 'keycloak resources limits memory'

  # Ldap Config
  - variable: config.keycloak.ldap.enabled
    description: ''
    type: boolean
    required: true
    label: enabled
    show_subquestion_if: true
    group: 'Ldap Config'
    subquestions:
      - variable: config.keycloak.ldap.integration
        description: ''
        type: string
        required: false
        label: integration
      - variable: config.keycloak.ldap.hostname
        description: ''
        type: string
        required: true
        label: hostname
        show_if: config.keycloak.ldap.integration=
      - variable: config.keycloak.ldap.domain
        description: 'use example.org instead of dc=example,dc=org'
        type: string
        required: true
        label: domain
        show_if: config.keycloak.ldap.integration=
      - variable: config.keycloak.ldap.username
        description: ''
        type: string
        required: true
        label: username
        show_if: config.keycloak.ldap.integration=
      - variable: config.keycloak.ldap.password
        description: ''
        type: password
        required: true
        label: password
        show_if: config.keycloak.ldap.integration=
      - variable: config.keycloak.ldap.userObjectClasses
        description: ''
        type: string
        required: true
        label: 'user object classes'
      - variable: config.keycloak.ldap.tls.enabled
        description: ''
        type: boolean
        required: true
        label: 'tls enabled'
        show_if: config.keycloak.ldap.integration=
      - variable: config.keycloak.ldap.tls.ca
        description: ''
        type: string
        required: false
        show_if: config.keycloak.ldap.tls.enabled=true&&config.keycloak.ldap.integration=
        label: 'tls ca'

  # Smtp Config
  - variable: config.keycloak.smtp.enabled
    description: ''
    type: boolean
    required: true
    label: enabled
    show_subquestion_if: true
    group: 'Smtp Config'
    subquestions:
      - variable: config.keycloak.smtp.integration
        description: ''
        type: string
        required: false
        label: integration
      - variable: config.keycloak.smtp.from
        description: ''
        type: string
        required: true
        label: from
      - variable: config.keycloak.smtp.hostname
        description: ''
        type: string
        required: true
        label: hostname
        show_if: config.keycloak.smtp.integration=
      - variable: config.keycloak.smtp.port
        description: ''
        type: int
        required: true
        label: port
        show_if: config.keycloak.smtp.integration=
      - variable: config.keycloak.smtp.username
        description: ''
        type: string
        required: true
        label: username
        show_if: config.keycloak.smtp.integration=
      - variable: config.keycloak.smtp.password
        description: ''
        type: password
        required: true
        label: password
        show_if: config.keycloak.smtp.integration=

  # Postgres Config
  - variable: config.postgres.integration
    description: ''
    type: string
    required: false
    label: integration
    group: 'Postgres Config'
  - variable: config.postgres.host
    description: ''
    type: string
    required: true
    label: host
    show_if: config.postgres.integration=
    group: 'Postgres Config'
  - variable: config.postgres.database
    description: 'only letters, digits and _ allowed'
    type: string
    required: true
    label: database
    group: 'Postgres Config'
  - variable: config.postgres.username
    description: ''
    type: string
    required: true
    label: username
    show_if: config.postgres.integration=
    group: 'Postgres Config'
  - variable: config.postgres.password
    description: ''
    type: password
    required: true
    label: password
    show_if: config.postgres.integration=
    group: 'Postgres Config'
  - variable: config.postgres.port
    description: ''
    type: int
    min: 0
    max: 65535
    required: true
    label: port
    show_if: config.postgres.integration=
    group: 'Postgres Config'
  # - variable: config.postgres.url
  #   description: ''
  #   type: string
  #   required: false
  #   label: url
  #   group: 'Postgres Config'

  # # Persistence
  # - variable: persistence.enabled
  #   description: ''
  #   type: boolean
  #   required: true
  #   label: enabled
  #   show_subquestion_if: true
  #   group: Persistence
  #   subquestions:
  #     - variable: persistence.size.keycloak
  #       description: ''
  #       type: string
  #       required: true
  #       label: 'keycloak size'
  #     - variable: persistence.storageClass
  #       description: ''
  #       type: storageclass
  #       required: false
  #       label: 'storage class'
  #     - variable: persistence.accessMode
  #       description: ''
  #       type: enum
  #       options:
  #         - ReadWriteOnce
  #         - ReadWriteMany
  #         - ReadOnlyMany
  #       required: false
  #       label: 'access mode'
  #     - variable: persistence.existingClaim.keycloak
  #       description: ''
  #       type: string
  #       required: false
  #       label: 'keycloak existing claim'
  #     - variable: persistence.velero.enabled
  #       description: ''
  #       type: boolean
  #       required: true
  #       label: 'velero enabled'
  #       group: Persistence
  #     - variable: persistence.velero.schedule
  #       description: ''
  #       type: string
  #       show_if: persistence.velero.enabled=true
  #       required: false
  #       label: 'velero schedule'
  #       group: Persistence
  #     - variable: persistence.velero.restic
  #       description: ''
  #       type: boolean
  #       show_if: persistence.velero.enabled=true
  #       required: true
  #       label: 'velero restic'
  #       group: Persistence
  #     - variable: persistence.velero.ttl
  #       description: ''
  #       type: string
  #       show_if: persistence.velero.enabled=true
  #       required: true
  #       label: 'velero ttl'
  #       group: Persistence

  # Services and Load Balancing
  - variable: ingress.keycloak.enabled
    description: ''
    type: boolean
    label: 'keycloak ingress enabled'
    show_subquestion_if: true
    group: 'Services and Load Balancing'
    subquestions:
      - variable: ingress.keycloak.tls
        description: ''
        type: boolean
        required: true
        label: 'keycloak ingress tls'
      - variable: ingress.keycloak.hostname
        default: xip.io
        description: ''
        type: hostname
        required: true
        label: 'keycloak ingress hostname'
      - variable: ingress.keycloak.issuer.name
        description: ''
        type: enum
        show_if: ingress.keycloak.tls=true
        options:
          - none
          - letsencrypt-cloudflare-staging
          - letsencrypt-cloudflare-prod
          - letsencrypt-staging
          - letsencrypt-prod
          - selfsigned
        required: true
        label: 'keycloak ingress issuer name'
      - variable: ingress.keycloak.certificate
        description: ''
        type: string
        show_if: ingress.keycloak.tls=true&&ingress.keycloak.issuer.name=none
        required: false
        label: 'keycloak ingress certificate'
  - variable: service.keycloak.type
    description: ''
    type: enum
    show_if: ingress.keycloak.enabled=false
    options:
      - ClusterIP
      - LoadBalancer
      - NodePort
    required: true
    label: 'keycloak service type'
    group: 'Services and Load Balancing'
  - variable: service.keycloak.nodePorts.http
    description: ''
    type: int
    required: false
    min: 30000
    max: 32767
    show_if: service.keycloak.type=NodePort&&ingress.keycloak.enabled=false
    label: 'keycloak http node port'
    group: 'Services and Load Balancing'
  - variable: service.keycloak.lbPorts.http
    description: ''
    type: int
    min: 0
    max: 65535
    required: true
    show_if: service.keycloak.type=LoadBalancer&&ingress.keycloak.enabled=false
    label: 'keycloak http lb port'
    group: 'Services and Load Balancing'

  # Images
  - variable: images.keycloak.repository
    description: ''
    type: string
    required: true
    label: 'keycloak repository'
    group: Images
  - variable: images.keycloak.tag
    description: ''
    type: string
    required: true
    label: 'keycloak tag'
    group: Images
